﻿/*
© Ivan Dembicki, 2004, dembicki@narod.ru
please check updates: http://www.dembicki.org

Path class 
version 1.2 

rewritten by Markus Mueller, markus@mindnode.com
*/
class org.dembicki.Path {
	var path_points:String = "", path_length:Number = 0;
	var segments:Number = 0;
	private var ln_array:Array;
	
	function Path() {
		var arg = typeof arguments[0] == "number" ? arguments : arguments[0];
		this.path_points=arg.toString(), this.path_length=0;
		var k = 0, i;
		var len = arg.length;
		var x0 = arg[0] || 0, y0 = arg[1] || 0, x1, y1, x2, y2, dX, dY;
		this.ln_array = new Array();
		this.ln_array[0] = {_ln: 0, _x:x0, _y:y0};
		for (i=2; i<len; i += 4) {
			x1 = arg[i] || 0;
			y1 = arg[i+1] || 0;
			if (i == (len-2)) {
				x2 = arg[i+2] ? arg[i+2] : (arg[0] || 0);
				y2 = arg[i+3] ? arg[i+3] : (arg[1] || 0);
			} else {
				x2 = arg[i+2] || 0;
				y2 = arg[i+3] || 0;
			}
		
			dX = x2 - x0;
			dY = y2 - y0;
			this.path_length += Math.floor(Math.abs(Math.sqrt(Math.pow(dX, 2) + Math.pow(dY, 2)))); //pythagoras
			
			x0 = x2;
			y0 = y2;
			k++;
			this.ln_array[k]={_ln: this.path_length, _x:x0, _y:y0};
		}
		this.segments = k;
	}
	
	public function getPoint(poz:Number, omit_rotation:Boolean):Object {
		var i,k,x0,y0,x1,y1,dx,dy,dpoz:Number;
		var obj,obj2:Object;

         if (poz > this.path_length) {
             poz = this.path_length;
         } else if (poz < 0) {
             poz = 0;
         }
		
		k = this.segments;
		for (i=0; i<k; i++) {
			obj = this.ln_array[i+1];
			if (obj._ln >= poz) {
				obj2 = this.ln_array[i];

				x1 = obj._x;
				y1 = obj._y;
				x0 = obj2._x;
				y0 = obj2._y;
				
				dx = x1 - x0;
				dy = y1 - y0;
				dpoz = (poz - obj2._ln) / (obj._ln - obj2._ln);
				
				//trace(poz);
				//trace(dpoz);
				return {_x:x0+(dx*dpoz), _y:y0+(dy*dpoz)};
			}
		}
		return {_x:0, _y:0}; // unexpected branche
	}
}
